# 添加多个源码文件

当项目由多个源码文件组成时，就可以将其逐一添加到`add_executable`中（包括.h 头文件和.cpp 源码文件），来使 makefile 能够对其进行编译。但是当文件过多时，就会显得十分繁琐，可以使用 CMake 提供的`aux_source_directory`来对当前目录中的源文件进行收集。修改后的配置文件格式为：

```cmake
project(Demo)
aux_source_directory(. DIR_SRCS)
add_executable(Demo ${DIR_SRCS})
```

`aux_source_directory`将源码文件收集到了`DIR_SRCS`变量中，然后在`add_executable`中使用`${DIR_SRCS}`的格式应用了其中的内容。
