# 基本配置

CMake 的基本配置只有三行，用于定义当前的项目名称和程序源码文件。基本内容如下：

```cmake
cmake_minimum_required (VERSION 2.6)
project(项目名称)
add_executable(项目名称 源码文件列表)
```

其中第一行指定了编译本文件所需的 CMake 程序版本。`project`定义了项目代号，`add_executable`为`project`定义的项目指定了需要编译的源代码文件。

基本配置中，还可以使用`set(CMAKE_CXX_STANDARD n)`来指定 C++的标准版本，例如使用 C++11 就可以使用配置`set(CMAKE_CXX_STANDARD 11)`。对于不同的系统环境，CMake 会自动寻找可用的编译器，但是也可以通过设置`CMAKE_C_COMPILER`和`CMAKE_CXX_COMPILER`两个变量来指定要使用的编译器，指定时需要写明编译器可执行文件的具体路径。

```admonish tip
CMake配置中，圆括号中的参数一般都使用空格隔开。对于字符串参数，一般可以不必书写双引号。
```
