循环语句

C++中的循环语句有三种：`for`语句、`do`语句和`while`语句。

### `for`循环

for 循环一般用于有限次数的循环执行，其格式为：

```c++
for (初始化表达式;终止条件判断表达式;变化表达式) {
    循环体;
}
```

for 循环中的三个表达式都可以省略，但是用于分隔的分号不可省略。

for 循环的执行流程图为：

```dot process
digraph {
  bgcolor=transparent;
  node [color="#888888", fontcolor="#888888"];
  edge [color="#888888", fontcolor="#888888"];

  ent [shape=oval, label="入口"];
  init [shape=rectangle, label="初始化表达式"];
  loop_cond [shape=diamond, label="判断终止条件表达式"];
  exit [shape=oval, label="出口"];
  loop_body [shape=rectangle, label="循环体"];
  change [shape=rectangle, label="执行变化表达式"];

  {rank=same; exit; loop_cond}

  ent -> init -> loop_cond;
  loop_cond -> loop_body [label="表达式为假", headport=n, tailport=s];
  loop_body -> change;
  loop_cond -> exit [label="表达式为真", headport=w, tailport=e, splines=line];
  change -> loop_cond [headport=w, tailport=w];
}
```

## `do`循环

do 循环用于进行至少执行一次的循环，其格式为：

```c++
do {
    循环体;
} while (终止条件判断表达式);
```

do 循环的流程图为：

```dot process
digraph {
  bgcolor=transparent;
  node [color="#888888", fontcolor="#888888"];
  edge [color="#888888", fontcolor="#888888"];

  ent [shape=oval, label="入口"];
  loop_cond [shape=diamond, label="判断终止条件表达式"];
  exit [shape=oval, label="出口"];
  loop_body [shape=rectangle, label="循环体"];

  {rank=same; exit; loop_cond}

  ent -> loop_body -> loop_cond;
  loop_cond -> exit [label="表达式为假", headport=w, tailport=e];
  loop_cond -> loop_body [label="表达式为真", headport=w, tailport=w];
}
```

## `while`循环

while 循环与 do 循环类似，但是判断终止条件在最开始。使用格式为：

```c++
while (判断终止条件) {
    循环体;
}
```

while 循环的流程图为：

```dot process
digraph {
  bgcolor=transparent;
  node [color="#888888", fontcolor="#888888"];
  edge [color="#888888", fontcolor="#888888"];

  ent [shape=oval, label="入口"];
  loop_cond [shape=diamond, label="判断终止条件表达式"];
  exit [shape=oval, label="出口"];
  loop_body [shape=rectangle, label="循环体"];

  {rank=same; exit; loop_cond}

  ent -> loop_cond;
  loop_cond -> exit [label="表达式为假", headport=w, tailport=e];
  loop_cond -> loop_body [label="表达式为真", headport=n, tailport=s];
  loop_body -> loop_cond [headport=w, tailport=w];
}
```

## 循环控制

C++中的循环控制主要是由两个语句提供的：

- `break`，终止并退出当前循环，当前循环体中的剩余语句将被跳过。
- `continue`，结束本次循环，跳过当前循环体中的剩余语句，从条件判断继续执行。
