# 文件处理

标准库`<fstream>`中提供了`ofstream`、`ifstream`和`fstream`来对文件进行操作，其中`ofstream`用于向文件输出，`ifstream`用于从文件输入，`fstream`用于双向操作。

`ofstream`、`ifstream`和`fstream`中提供了`open()`成员函数来打开文件，`open()`函数的声明为：`void open(const char *filename, ios::openmode mode)`。其中第一个参数为要打开的文件名，第二个参数为打开模式。文件的打开模式可选择以下值。

- `ios::app`，在文件末尾追加。
- `ios::ate`，指针定位到问价末尾。
- `ios::in`，只读方式打开。
- `ios::out`，只写方式打开。
- `ios::trunc`，重置已经存在的文件内容。

当文件使用完毕后，需要及时关闭，可以使用成员函数`close()`。

具体文件操作可参考以下示例：

```c++
std::fstream file;
file.open("file.dat", ios::out | ios::in);
file << "Hello World." << std::endl;
file.close();
```
