# 数组

数组可以用来存储相同类型元素的固定大小的集合。数组中的元素可以通过索引进行访问。数组的声明格式为`类型 数组名[数组大小]`，例如`int arr[10]`。对数组内元素的访问格式为`数组名[索引号]`，例如`arr[5]`。C++中数组的索引从 0 开始计算。

## 初始化

数组在使用前必须完成初始化，数组的初始化格式为`类型 数组名[数组大小]={用于初始化的值}`，例如`int a[2] = {1, 2}`。大括号中用于初始化数组的值的数量不能大于指定的数组大小，例如这样是错误的：`int a[2] = {1, 2, 4}`。如果在声明数组时省略了数组大小的设定，那么数组的大小将为初始化时大括号列表中值的个数，例如`int a[] = {1, 2}`，此时数组`a`长度为 2。

```admonish caution
未初始化的数组尽量不要直接访问其中元素的内容，未初始化的数组中元素的内容是不确定的。
```

## 修改元素的值

数组的大小是固定的，但是数组中元素的值是可修改的。要修改指定元素的值，只需要对相应的索引元素直接赋值即可，例如`arr[3]=50`。

## 多维数组

C++支持多维数组。要理解多维数组的概念，需要首先从二维数组开始。二维数组可以称为数组的数组，其声明格式为`类型 数组名[一维大小][二维大小]`。二维数组可以看做是一个二维的表格，对于其中元素的访问也同样是使用索引，只是索引号是两个，例如`arr[4][5]`。二维数组的初始化与一维数组一致，只是其中的每个元素都是一个新的数组。

三维数组可以看做二维数组组成的数组，也就是表的组合，在声明时只需要追加声明一个数组大小即可。

依次后推，多维数组每增加一个维度，只需要增加一个数组大小的定义即可，对其中元素进行访问时，每个索引都使用一对独立的方括号。
